{$M 10240,0,2048}
Program WeedOut;

Uses
Cursor,Crt,Dos;

Const
DiskC = '\DISK';

Var
Top,Bot : Byte;
Check,LFile : String;
Messages,Allfiles,Listfiles : Boolean;

Procedure ParamCheck;

Var
I,J : Integer;
S : PathStr;
DiskOk,FileOk,Invalid : Boolean;

Procedure NoParams;

Begin
  ClrScr;
  Writeln(' Ŀ');
  Writeln('     WEEDOUT V 1.0 - (C) G.K.N. H.S.P. July 1995, Program by Phnkmeister    ');
  Writeln('         Program for deleting unwanted or unauthorised files on disks        ');
  Writeln('                                                                             ');
  Writeln('    SYNTAX  : WEEDOUT [OPTIONS]                                              ');
  Writeln('                                                                             ');
  Writeln('    OPTIONS :  -F:[Name of file(s)]  -D:[Disk letter]  -M:[True|False]       ');
  Writeln('               -A:[True|False]       -L:[Name of list file]                  ');
  Writeln('                                                                             ');
  Writeln('   -D: option will default to -D:C (Drive C:) if not given                   ');
  Writeln('                                                                             ');
  Writeln('   -M:T|F option is Messages True|False. Default is -M:T (Messages on)       ');
  Writeln('                                                                             ');
  Writeln('   -A:T|F option is Allfiles True|False. Default is -A:F (Allfiles off)      ');
  Writeln('                                                                             ');
  Writeln('   -L: creates list of files specified by -F: and will not delete anything   ');
  Writeln('                                                                             ');
  Writeln('      USE WITH CAUTION - This program will NOT ask to confirm DELETES !      ');
  Writeln('           This program also requires WHERE.COM to be on the path            ');
  Writeln('                                                                             ');
  Writeln('    ERRORLEVELS : 0-Normal, 1-This info, 2-Invalid params, 3-Nothing to do   ');
  Writeln(' ');
  CursorOn(Top,Bot);
  Halt(1);
End;

Procedure InvParams;

Begin
  Writeln(' For a list of parameters, run the program again with no parameters');
  CursorOn(Top,Bot);
  Halt(2);
End;

Begin
Check := '';
LFile := '';
FileOk := False;
DiskOk := False;
Messages := True;
Allfiles := False;
Listfiles := False;
Invalid := False;
If ParamCount = 0 Then NoParams;
For I := 1 To ParamCount Do
  Begin
    S := ParamStr(I);
    If (S[1] = '-') And (S[3] = ':') And (S[4] <> '') Then
      Case UpCase(S[2]) Of
        'F': Begin
               For J := 4 To Length(S) Do
                 Check := Check + S[J];
               FileOk := True;
             End;
        'D': Begin
               ChDir(S[4]+':\');
               DiskOk := True;
             End;
        'M': Case(UpCase(S[4])) Of
               'T' : Messages := True;
               'F' : Messages := False;
             Else
               Begin
                 WriteLn(' Invalid option : ', S);
                 Invalid := True;
               End;
             End;
        'A': Case(UpCase(S[4])) Of
               'T' : Allfiles := True;
               'F' : Allfiles := False;
             Else
               Begin
                 WriteLn(' Invalid option : ', S);
                 Invalid := True;
               End;
             End;
        'L': Begin
               For J := 4 To Length(S) Do
               LFile := LFile + S[J];
               ListFiles := True;
             End;
      Else
        Begin
          WriteLn(' Invalid option : ', S);
          Invalid := True;
        End;
      End;
  End;
If Not(FileOk) And Not(Invalid) Then
  Begin
    Writeln(' No File(s) specified !');
    Invalid := True;
  End;
If Not(DiskOk) And Not(Invalid) Then ChDir('C:\');
If Invalid Then InvParams;
End;

Procedure LeaveCheck;

Const
Leave = 'LEAVE_ME';

Var
DirInfo : SearchRec;

Begin
FindFirst('\'+Leave,ReadOnly+Hidden+SysFile+Archive,DirInfo);
If (Leave = DirInfo.Name) Then
  Begin
    CursorOn(Top,Bot);
    Halt(0);
  End;
End;

Procedure Nothing;

Begin
  If Messages Then Writeln('Nothing to do !');
  CursorOn(Top,Bot);
  Halt(3);
End;

Procedure Trim(Var S1,S2 : String;CT : String;I : Integer);

Var
LC,S3 : String;

Begin
S3 := S1;
Repeat
LC := Copy(S1,Length(S1),1);
If LC <> CT Then
S1 := Copy(S1,1,Length(S1)-1);
Until LC = CT ;
S2 := Copy(S3,Length(S1)+1,Length(S3));
If I = 2 Then S1 := S3;
End;

Procedure EraseAll(S1 : String;Var L : Text);

Var
Del : File;
S2 : String;
DirInfo : SearchRec;

Begin
Trim(S1,S2,'\',1);
FindFirst(S1+'*.*',ReadOnly+Hidden+SysFile+Archive,DirInfo);
While DosError = 0 Do
  Begin
    If ListFiles Then
      Writeln(L,S1+DirInfo.Name)
    Else
      Begin
        Assign(Del,S1+DirInfo.Name);
        SetFAttr(Del,0);
        Erase(Del);
      End;
    FindNext(DirInfo);
  End;
End;

Procedure EraseOne(S : String;Var L : Text);

Var
Del : File;

Begin
If ListFiles Then
  Writeln(L,S)
Else
  Begin
    Assign(Del,S);
    SetFAttr(Del,0);
    Erase(Del);
  End;
End;

Procedure Main;

Var
DiskFile,Line,Name : String;
I : Integer;
Info : String[29];
Disk,List : Text;
DirInfo : SearchRec;
Chk : File Of Byte;
AddTo : Boolean;

Begin
DiskFile := GetEnv('TEMP')+DiskC;
If Messages Then
  Begin
    Writeln(' Ŀ');
    Writeln('     WEEDOUT V 1.0 - (C) G.K.N. H.S.P. July 1995, Program by Phnkmeister    ');
    Writeln(' ');
    Write(' Scanning for file(s) .... ');
  End;
SwapVectors;
Exec(GetEnv('COMSPEC'),' /C WHERE '+Check+' >'+DiskFile);
SwapVectors;
Assign(Chk,DiskFile);
Reset(Chk);
If (FileSize(Chk) = 0) Then Nothing Else If Messages Then Write('Processing Files .... ');
Close(Chk);
If ListFiles Then
  Begin
    Trim(LFile,Name,'\',2);
    For I := 1 To Length(Name) Do
      Name[I] := UpCase(Name[I]);
    FindFirst(LFile,ReadOnly+Hidden+SysFile+Archive,DirInfo);
    Assign(List,LFile);
    If (Name = DirInfo.Name) Then
      Append(List)
    Else
      ReWrite(List);
  End;
Assign(Disk,DiskFile);
Reset(Disk);
Repeat
Readln(Disk,Info,Line);
Case Allfiles Of
   True : EraseAll(Line,List);
  False : EraseOne(Line,List);
End;
Until Eof(Disk);
Close(Disk);
Erase(Disk);
If ListFiles Then Close(List);
If Messages Then Writeln('Done !');
End;

Begin
CursorSize(Top,Bot);
CursorOff;
ParamCheck;
LeaveCheck;
Main;
CursorOn(Top,Bot);
Halt(0);
End.